package cn.ibizlab.assetmanagement.core.apply.service.impl;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;
import java.util.Set;
import java.util.Map;
import java.util.HashSet;
import java.util.HashMap;
import java.util.Collection;
import java.util.Objects;
import java.util.Optional;
import java.math.BigInteger;

import lombok.extern.slf4j.Slf4j;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.cglib.beans.BeanCopier;
import org.springframework.stereotype.Service;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageImpl;
import org.springframework.data.domain.Pageable;
import org.springframework.util.ObjectUtils;
import io.seata.spring.annotation.GlobalTransactional;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.context.annotation.Lazy;
import cn.ibizlab.assetmanagement.core.apply.domain.EAMApplyStateModel;
import cn.ibizlab.assetmanagement.core.apply.filter.EAMApplyStateModelSearchContext;
import cn.ibizlab.assetmanagement.core.apply.service.IEAMApplyStateModelService;

import cn.ibizlab.assetmanagement.util.helper.CachedBeanCopier;
import cn.ibizlab.assetmanagement.util.helper.DEFieldCacheMap;


import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import cn.ibizlab.assetmanagement.core.apply.mapper.EAMApplyStateModelMapper;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.conditions.Wrapper;
import com.alibaba.fastjson.JSONObject;
import org.springframework.util.StringUtils;

/**
 * 实体[维护申请状态模型] 服务对象接口实现
 */
@Slf4j
@Service("EAMApplyStateModelServiceImpl")
public class EAMApplyStateModelServiceImpl extends ServiceImpl<EAMApplyStateModelMapper, EAMApplyStateModel> implements IEAMApplyStateModelService {

    @Autowired
    @Lazy
    protected cn.ibizlab.assetmanagement.core.apply.service.IEAMApplyStateModelLineService eamapplystatemodellineService;
    @Autowired
    @Lazy
    protected cn.ibizlab.assetmanagement.core.apply.service.IEAMApplyTypeService eamapplytypeService;

    protected int batchSize = 500;

    @Override
    @Transactional
    public boolean create(EAMApplyStateModel et) {
        if(!this.retBool(this.baseMapper.insert(et)))
            return false;
        CachedBeanCopier.copy(get(et.getEamapplystatemodelid()),et);
        return true;
    }

    @Override
    public void createBatch(List<EAMApplyStateModel> list) {
        this.saveBatch(list,batchSize);
    }

    @Override
    @Transactional
    public boolean update(EAMApplyStateModel et) {
        if(!update(et,(Wrapper) et.getUpdateWrapper(true).eq("eamapplystatemodelid",et.getEamapplystatemodelid())))
            return false;
        CachedBeanCopier.copy(get(et.getEamapplystatemodelid()),et);
        return true;
    }

    @Override
    public void updateBatch(List<EAMApplyStateModel> list) {
        updateBatchById(list,batchSize);
    }

    @Override
    @Transactional
    public boolean remove(String key) {
        boolean result=removeById(key);
        return result ;
    }

    @Override
    public void removeBatch(Collection<String> idList) {
        removeByIds(idList);
    }

    @Override
    @Transactional
    public EAMApplyStateModel get(String key) {
        EAMApplyStateModel et = getById(key);
        if(et==null){
            et=new EAMApplyStateModel();
            et.setEamapplystatemodelid(key);
        }
        else{
        }
        return et;
    }

    @Override
    public EAMApplyStateModel getDraft(EAMApplyStateModel et) {
        return et;
    }

    @Override
    public boolean checkKey(EAMApplyStateModel et) {
        return (!ObjectUtils.isEmpty(et.getEamapplystatemodelid()))&&(!Objects.isNull(this.getById(et.getEamapplystatemodelid())));
    }
    @Override
    @Transactional
    public boolean save(EAMApplyStateModel et) {
        if(!saveOrUpdate(et))
            return false;
        return true;
    }

    @Override
    @Transactional
    public boolean saveOrUpdate(EAMApplyStateModel et) {
        if (null == et) {
            return false;
        } else {
            return checkKey(et) ? this.update(et) : this.create(et);
        }
    }

    @Override
    public boolean saveBatch(Collection<EAMApplyStateModel> list) {
        saveOrUpdateBatch(list,batchSize);
        return true;
    }

    @Override
    public void saveBatch(List<EAMApplyStateModel> list) {
        saveOrUpdateBatch(list,batchSize);
    }



    /**
     * 查询集合 DEFAULT
     */
    @Override
    public Page<EAMApplyStateModel> searchDefault(EAMApplyStateModelSearchContext context) {
        com.baomidou.mybatisplus.extension.plugins.pagination.Page<EAMApplyStateModel> pages=baseMapper.searchDefault(context.getPages(),context,context.getSelectCond());
        return new PageImpl<EAMApplyStateModel>(pages.getRecords(), context.getPageable(), pages.getTotal());
    }







    @Override
    public List<JSONObject> select(String sql, Map param){
        return this.baseMapper.selectBySQL(sql,param);
    }

    @Override
    @Transactional
    public boolean execute(String sql , Map param){
        if (sql == null || sql.isEmpty()) {
            return false;
        }
        if (sql.toLowerCase().trim().startsWith("insert")) {
            return this.baseMapper.insertBySQL(sql,param);
        }
        if (sql.toLowerCase().trim().startsWith("update")) {
            return this.baseMapper.updateBySQL(sql,param);
        }
        if (sql.toLowerCase().trim().startsWith("delete")) {
            return this.baseMapper.deleteBySQL(sql,param);
        }
        log.warn("暂未支持的SQL语法");
        return true;
    }

    @Override
    public List<EAMApplyStateModel> getEamapplystatemodelByIds(List<String> ids) {
         return this.listByIds(ids);
    }

    @Override
    public List<EAMApplyStateModel> getEamapplystatemodelByEntities(List<EAMApplyStateModel> entities) {
        List ids =new ArrayList();
        for(EAMApplyStateModel entity : entities){
            Serializable id=entity.getEamapplystatemodelid();
            if(!ObjectUtils.isEmpty(id)){
                ids.add(id);
            }
        }
        if(ids.size()>0)
           return this.listByIds(ids);
        else
           return entities;
    }

}



